--7 Segments Driver
--Miguel A. Aguirre Echanove. University of Sevilla (SPAIN)
--Dpt. of Ingenieria Electronica. aguirre@gte.esi.us.es
--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity segment7kk is
    port (
        entrada: in STD_LOGIC_VECTOR (3 downto 0);
        A: out STD_LOGIC;
        B: out STD_LOGIC;
        C: out STD_LOGIC;
        D: out STD_LOGIC;
        E: out STD_LOGIC;
        F: out STD_LOGIC;
        G: out STD_LOGIC
    );
end segment7kk;

architecture segment7kk_arch of segment7kk is
signal entry: integer range 0 to 15;
begin
entry<=conv_integer(entrada);
process (entry)
begin
-- segment encoding
--      A
--     ---  
--  B |   | F
--     ---   <- G
--  C |   | E
--     ---
--      D



A<='0';
B<='0';
C<='0';
D<='0';
E<='0';
F<='0';
G<='0';
case entry is
	when 0 =>
		A<='1';B<='1';C<='1';D<='1';E<='1';F<='1';
	when 1 =>
		F<='1';E<='1';
	when 2 =>
		A<='1';G<='1';C<='1';D<='1';F<='1';
	when 3 =>
		G<='1';A<='1';F<='1';D<='1';E<='1';
	when 4 =>
		G<='1';B<='1';E<='1';F<='1';
	when 5 =>
		A<='1';B<='1';G<='1';D<='1';E<='1';
	when 6 =>
		A<='1';G<='1';B<='1';C<='1';D<='1';E<='1';
	when 7 =>
		A<='1';F<='1';E<='1';
	when 8 =>
		A<='1';G<='1';B<='1';C<='1';D<='1';E<='1';F<='1';
	when 9 =>
		A<='1';G<='1';B<='1';E<='1';F<='1';
	when 10 =>
		A<='1';G<='1';B<='1';C<='1';E<='1';F<='1';
	when 11 =>
		B<='1';E<='1';G<='1';C<='1';D<='1';
	when 12 =>
		G<='1';C<='1';D<='1';
	when 13 =>
		G<='1';E<='1';C<='1';D<='1';F<='1';
	when 14 =>
		A<='1';B<='1';C<='1';D<='1';F<='1';G<='1';
	when others =>
		A<='1';B<='1';C<='1';G<='1';
end case;
end process;
end segment7kk_arch;
