--Mux for read byte
--Miguel A. Aguirre Echanove. University of Sevilla (SPAIN)
--Dpt. of Ingenieria Electronica. aguirre@gte.esi.us.es
--

library IEEE;
use IEEE.std_logic_1164.all;

entity Mux4 is
    generic( N:Integer:=8);
    port (
        r0: in STD_LOGIC_VECTOR(N-1 downto 0);
        r1: in STD_LOGIC_VECTOR(N-1 downto 0);
        r2: in STD_LOGIC_VECTOR(N-1 downto 0);
        r3: in STD_LOGIC_VECTOR(N-1 downto 0);
        paddr: in STD_LOGIC_VECTOR(3 downto 0);
        rd: out STD_LOGIC_VECTOR(N-1 downto 0)
    );
end Mux4;

architecture Mux4_arch of Mux4 is
begin
process(r0,r1,r2,r3,paddr)
begin
	if(paddr(0)='1') then
		rd<=r0;
	elsif(paddr(1)='1') then
	  	rd<=r1;
	elsif(paddr(2)='1') then
	  	rd<=r2;
	elsif(paddr(3)='1') then
	  	rd<=r3;
	else 
		for i in 0 to N-1 loop rd(i)<='0';
		end loop;
	end if;
end process;
end Mux4_arch;
