--Generic register...
--Miguel A. Aguirre Echanove. University of Sevilla (SPAIN)
--Dpt. of Ingenieria Electronica. aguirre@gte.esi.us.es
--

library IEEE;
use IEEE.std_logic_1164.all;

entity RegSinc is
    generic(N: integer :=8);
    port (
        clk: in STD_LOGIC;
        reset: in STD_LOGIC;
        load: in STD_LOGIC; 
        din: in STD_LOGIC_VECTOR (N-1 downto 0);
        dout: out STD_LOGIC_VECTOR (N-1 downto 0)
    );
end RegSinc;

architecture RegSinc_arch of RegSinc is
signal aux,doutaux: STD_LOGIC_VECTOR (N-1 downto 0);
begin
process (din,doutaux,load)
begin
	   if(load='1') then
	   	aux<=din;
	   else
	   	aux<=doutaux;
	   end if;
end process;

process(clk,reset,doutaux,load)
begin
	if(reset='1') then
	   for i in 0 to N-1 loop
	      doutaux(i)<='0';
	   end loop;
	 elsif(clk='1') and (clk'event) then
		doutaux<=aux;
	 end if;
end process;
dout<=doutaux; --It's not quite elegant, but Xilinx recommends it;
end RegSinc_arch;
