--Decoder for Address Selection
--Miguel A. Aguirre Echanove. University of Sevilla (SPAIN)
--Dpt. of Ingenieria Electronica. aguirre@gte.esi.us.es
--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity decod is
    generic(
    	N: INTEGER :=2;
    	M: INTEGER :=4
    	);
    	
    port (
    	enable : in STD_LOGIC;
        address: in STD_LOGIC_VECTOR (N-1 downto 0);
        pointers: out STD_LOGIC_VECTOR (M-1 downto 0)
    );
end decod;

architecture decod_arch of decod is
signal aux: INTEGER;
begin
aux<=conv_integer(address);
process(enable,aux)
begin
     if (enable='1') then
	for i in 0 to M-1 loop
	   if aux=i then
	   	pointers(i)<='1' ;
	   else
	   	pointers(i)<='0' ;
	   end if;
	end loop;
     else
 	for i in 0 to M-1 loop
	   	pointers(i)<='0' ;
	end loop;
     end if;
    	
end process;
end decod_arch;
