--Fsm For Access Protocol
--Miguel A. Aguirre Echanove. University of Sevilla (SPAIN)
--Dpt. of Ingenieria Electronica. aguirre@gte.esi.us.es
--
library IEEE;
use IEEE.std_logic_1164.all;

entity fsmrdwr is
    port (
        clk: in STD_LOGIC;
        rst: in STD_LOGIC;
        wrexb: in STD_LOGIC;
        rdexb: in STD_LOGIC;
        wrint: out STD_LOGIC;
        aleint: out STD_LOGIC;
        rdint: out STD_LOGIC;
        nibble: out STD_LOGIC
    );
end fsmrdwr;

architecture fsmrdwr_arch of fsmrdwr is
type state is (reposo,espescr,escribe,espdir,capdir,esplee0,lee0,esplee1,lee1);
signal prestate,nextstate : state;
begin
fsm : process (wrexb,rdexb,prestate)
begin

case prestate is
	when reposo =>--estado de partida
		wrint<='0';rdint<='0';aleint<='0';nibble<='0';		
		if(wrexb='1')and(rdexb='1') then 
			nextstate <= reposo;
		elsif(wrexb='0')and(rdexb='1') then
			nextstate <= espescr;
		elsif(wrexb='0')and(rdexb='0') then
			nextstate <= espdir;
		else
			nextstate <= esplee0;
		end if;
	when espescr =>--esperar a dar la orden de escritura
		wrint<='0';rdint<='0';aleint<='0';nibble<='0';		
		if(wrexb='0')and(rdexb='1') then
			nextstate <= espescr;
		elsif(wrexb='0')and(rdexb='0') then
			nextstate <= espdir;
		else
			nextstate <= escribe;
		end if;
	when escribe =>--dar orden de escritura
		rdint<='0';aleint<='0';nibble<='0';		
		wrint <='1';
		if(wrexb='1')and(rdexb='1') then 
			nextstate <= reposo;
		else				
			nextstate <= escribe;
		end if;
	when espdir =>--esperar a capturar la direccion
		wrint<='0';rdint<='0';aleint<='0';nibble<='0';		
		if(wrexb='0')and(rdexb='0') then
			nextstate <= espdir;
		else
			nextstate <= capdir;
		end if;			
	when capdir =>--capturar direccion
		wrint<='0';rdint<='0';nibble<='0';		
		aleint<='1';
		if(wrexb='1')and(rdexb='1') then 
			nextstate <= reposo;
		else				
			nextstate <= capdir;
		end if;	
			
	when esplee0 =>--esperar a leer
		wrint<='0';rdint<='0';aleint<='0';nibble<='0';		
		if(wrexb='1')and(rdexb='0') then
			nextstate <= esplee0;
		elsif(wrexb='0')and(rdexb='0') then
			nextstate <= espdir;
		else
			nextstate <= lee0;
		end if;
	when lee0 =>--leer nibble menos significativo
		wrint<='0';aleint<='0';nibble<='0';		
		rdint<='1';
		if(rdexb='1') then 
			nextstate <= lee0;
		else				
			nextstate <= esplee1;
		end if;	
	when esplee1 =>--esperar a leer
		wrint<='0';rdint<='0';aleint<='0';nibble<='0';		
		if(wrexb='1')and(rdexb='0') then
			nextstate <= esplee1;
		elsif(wrexb='0')and(rdexb='0') then
			nextstate <= espdir;
		else
			nextstate <= lee1;
		end if;
	when lee1 =>--leer nibble mas significativo
		wrint<='0';aleint<='0';		
		rdint<='1';
		nibble<='1';--se ha de capturar el bit de nibble tambien
		if(wrexb='1')and(rdexb='1') then 
			nextstate <= reposo;
		else				
			nextstate <= lee1;
		end if;	
	end case;
end process;
synch: process(clk,rst,nextstate)
begin
	if(rst='1') then
		prestate<=reposo;
	elsif (clk'event) and (clk='1') then
		prestate<=nextstate;
	end if;
end process;
end fsmrdwr_arch;
